// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _CLUTTERMM_BEHAVIOUR_DEPTH_H
#define _CLUTTERMM_BEHAVIOUR_DEPTH_H


#include <glibmm.h>

/* Copyright (C) 2007 The cluttermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <cluttermm/behaviour.h>
#include <cluttermm/alpha.h>
 

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _ClutterBehaviourDepth ClutterBehaviourDepth;
typedef struct _ClutterBehaviourDepthClass ClutterBehaviourDepthClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Clutter
{ class BehaviourDepth_Class; } // namespace Clutter
namespace Clutter
{


class BehaviourDepth : public Behaviour
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef BehaviourDepth CppObjectType;
  typedef BehaviourDepth_Class CppClassType;
  typedef ClutterBehaviourDepth BaseObjectType;
  typedef ClutterBehaviourDepthClass BaseClassType;

private:  friend class BehaviourDepth_Class;
  static CppClassType behaviourdepth_class_;

private:
  // noncopyable
  BehaviourDepth(const BehaviourDepth&);
  BehaviourDepth& operator=(const BehaviourDepth&);

protected:
  explicit BehaviourDepth(const Glib::ConstructParams& construct_params);
  explicit BehaviourDepth(ClutterBehaviourDepth* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~BehaviourDepth();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  ClutterBehaviourDepth*       gobj()       { return reinterpret_cast<ClutterBehaviourDepth*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const ClutterBehaviourDepth* gobj() const { return reinterpret_cast<ClutterBehaviourDepth*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  ClutterBehaviourDepth* gobj_copy();

private:


protected:
  explicit BehaviourDepth(const Glib::RefPtr<Alpha>& alpha, int depth_start, int depth_end);

public:
  
  static Glib::RefPtr<BehaviourDepth> create(const Glib::RefPtr<Alpha>& alpha, int start_depth, int end_depth);


  /** Sets the boundaries of the @a behaviour.
   * 
   * Since: 0.6
   * @param depth_start Initial value of the depth.
   * @param depth_end Final value of the depth.
   */
  void set_bounds(int depth_start, int depth_end);
  
  /** Gets the boundaries of the @a behaviour
   * 
   * Since: 0.6
   * @param depth_start Return location for the initial depth value, or <tt>0</tt>.
   * @param depth_end Return location for the final depth value, or <tt>0</tt>.
   */
  void get_bounds(int& depth_start, int& depth_end);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Final depth to apply.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<int> property_depth_end() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Final depth to apply.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<int> property_depth_end() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Initial depth to apply.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<int> property_depth_start() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Initial depth to apply.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<int> property_depth_start() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Clutter


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Clutter::BehaviourDepth
   */
  Glib::RefPtr<Clutter::BehaviourDepth> wrap(ClutterBehaviourDepth* object, bool take_copy = false);
}


#endif /* _CLUTTERMM_BEHAVIOUR_DEPTH_H */

